/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <iostream>

#include <logf.h>
#include "imap4set.h"

dword set_commandt::get_uid_from_msgnr(dword msgnr)
 {
  if(msgnr>dboximap4.messages || msgnr<1) return 0;
  dboximap4.get_folderindex(msgnr-1);
  return dboximap4.fi.id;
 }

#if 0
dword set_commandt::getmsgnr_from_uid(dword uid)
 {
  folderindext fi;
  dword msgnr;

  if(getmsgnr_uid==uid)
    return getmsgnr_msgnr;

  if(getmsgnr_uid<uid &&
     getmsgnr_uid!=0 &&
     getmsgnr_msgnr!=0)
    msgnr=getmsgnr_msgnr;
  else
    msgnr=1;

  lseek(dboximap4.index, (msgnr-1)*sizeof fi, SEEK_SET);

  while(read(dboximap4.index, &fi, sizeof fi)==sizeof fi)
   {
    if(fi.id==uid)
     {
      getmsgnr_uid=fi.id;
      getmsgnr_msgnr=msgnr;
      return msgnr;
     }
    msgnr++;
   }

  // not found!

  return 0;
 }
#endif

dword set_commandt::getmsgnr_from_uid(dword uid, modet mode)
 {
  // binary search in sorted list

  if(dboximap4.messages==0) return 0;

  dword lower_bound=1, upper_bound=dboximap4.messages;

  while(TRUE)
   {
    dword lower_uid=get_uid_from_msgnr(lower_bound);
    dword upper_uid=get_uid_from_msgnr(upper_bound);

    if(lower_uid==uid) return lower_bound;
    if(upper_uid==uid) return upper_bound;

    if(upper_uid<uid)
     {
      if(mode==LOWER) return upper_bound;
      return 0;
     }
    else if(lower_uid>uid)
     {
      if(mode==UPPER) return lower_bound;
      return 0;
     }

    if((lower_bound+1)>=upper_bound) // not found
     {
      switch(mode)
       {
        case EXACT: return 0;
        case LOWER: return lower_bound;
        case UPPER: return upper_bound;
       }
     }

    dword msgnr=lower_bound+(upper_bound-lower_bound)/2;

    if(msgnr<=lower_bound) // safety
      msgnr=lower_bound+1;
    else if(msgnr>=upper_bound) // safety
      msgnr=upper_bound-1;

    dword m_uid=get_uid_from_msgnr(msgnr);

    if(m_uid==uid) return msgnr;

    if(m_uid>uid)
      upper_bound=msgnr;
    else // m_uid<uid
      lower_bound=msgnr;
   }

  return 0;
 }

bool set_commandt::do_set_command2()
 {
  if(uid)
    nr=getmsgnr_from_uid(nr);

  if(nr>dboximap4.messages || nr<1) return FALSE;

  return msg();
 }

void set_commandt::do_set_command(bool _uid)
 {
  uid=_uid;

  if(dboximap4.arguments.size()<unsigned(uid?2:1))
   {
    std::cout << dboximap4.tag << " NO provide more arguments\r\n";
    dboximap4.command_ok=FALSE;
    return;
   }

  argnr=uid?1:0;

  const char *message_set=dboximap4.arguments[argnr++].data.c_str();
  dword number=0, nr1=0, nr2=0;
  bool sequence=FALSE;
  dword max_value=uid?dboximap4.largest_id:dboximap4.messages;

  if(start())
    return;

  while(message_set[0]!=0)
   {
    if(isdigit(message_set[0]))
     {
      number=atol(message_set);
      while(isdigit(message_set[0])) message_set++;
     }
    else if(message_set[0]=='*')
     {
      number=max_value;
      message_set++;
     }

    if(message_set[0]==':')
     {
      nr1=number;
      sequence=TRUE;
     }
    else if(sequence)
     {
      nr2=number;
      sequence=FALSE;

      if(nr1<1) nr1=1;
      if(nr2>max_value) nr2=max_value;

      if(uid)
       {
        nr1=getmsgnr_from_uid(nr1, UPPER);
        nr2=getmsgnr_from_uid(nr2, LOWER);
        logf.printf("DEBUG", "nr1=%lu, nr2=%lu", nr1, nr2);
       }

      for(nr=nr1; nr<=nr2 && nr!=0; nr++)
        if(msg())
         {
          end();
          return;
         }
     }
    else
     {
      nr=number;
      if(do_set_command2())
       {
        end();
        return;
       }
     }

    if(message_set[0]!=0)
      message_set++;
   }

  end();
 }

