/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#ifndef WIN32
#include <unistd.h>
#endif

#include <strstream>
#include <iostream>

#include <stringtools.h>
#include "imap4store.h"

bool store_set_commandt::start()
 {
  const char *what=dboximap4.arguments[argnr++].data.c_str();

  if(stricmp(what, "FLAGS")==0)
    flags=TRUE;
  else if(stricmp(what, "FLAGS.SILENT")==0)
    flags=silent=TRUE;
  else if(stricmp(what, "+FLAGS")==0)
    flags=add=TRUE;
  else if(stricmp(what, "+FLAGS.SILENT")==0)
    flags=add=silent=TRUE;
  else if(stricmp(what, "-FLAGS")==0)
    flags=remove=TRUE;
  else if(stricmp(what, "-FLAGS.SILENT")==0)
    flags=remove=silent=TRUE;
  else
   {
    std::cout << dboximap4.tag
              << " NO Sorry, I do not know how to store this.\r\n";
    dboximap4.command_ok=FALSE;
    return TRUE;
   }

  dboximap4.get_folder_grants();
  if(!dboximap4.grants.write && !dboximap4.grants.keepseen)
   {
    std::cout << dboximap4.tag << " NO permission denied\r\n";
    dboximap4.command_ok=FALSE;
    return TRUE;
   }

  for(unsigned arg=argnr; arg<dboximap4.arguments.size(); arg++)
    if(!dboximap4.grants.write && 
       stringcasecmp(dboximap4.arguments[arg].data, "\\Seen")!=0)
     {
      std::cout << dboximap4.tag << " NO permission denied\r\n";
      dboximap4.command_ok=FALSE;
      return TRUE;
     }

  if(!dboximap4.grants.write && !remove)
   {
    std::cout << dboximap4.tag << " NO permission denied\r\n";
    dboximap4.command_ok=FALSE;
    return TRUE;
   }

  if(dboximap4.fp.lock())
   {
    std::cout << dboximap4.tag << " NO Sorry, failed to lock folder.\r\n";
    dboximap4.command_ok=FALSE;
    return TRUE;
   }

  return FALSE;
 }

bool store_set_commandt::msg()
 {
  dboximap4.get_folderindex(nr-1);

  if(!add && !remove)
   {
    dboximap4.fi.flags.imapflags=0;
    dboximap4.fi.flags.deleted=FALSE;
    dboximap4.fi.flags.seen=FALSE;
   }
 
  for(unsigned arg=argnr; arg<dboximap4.arguments.size(); arg++)
   {
    const char *item=dboximap4.arguments[arg].data.c_str();

    if(stricmp(item, "\\Answered")==0)
      dboximap4.fi.flags.imapflags^=
        (((dboximap4.fi.flags.imapflags&DBOXIMAP4_FLAG_Answered)==0)==!remove
        ?DBOXIMAP4_FLAG_Answered:0);
    else if(stricmp(item, "\\Flagged")==0)
      dboximap4.fi.flags.imapflags^=
        (((dboximap4.fi.flags.imapflags&DBOXIMAP4_FLAG_Flagged)==0)==!remove
        ?DBOXIMAP4_FLAG_Flagged:0);
    else if(stricmp(item, "\\Deleted")==0)
      dboximap4.fi.flags.deleted=!remove;
    else if(stricmp(item, "\\Seen")==0)
      dboximap4.fi.flags.seen=!remove;
    else if(stricmp(item, "\\Draft")==0)
      dboximap4.fi.flags.imapflags^=
        (((dboximap4.fi.flags.imapflags&DBOXIMAP4_FLAG_Draft)==0)==!remove
        ?DBOXIMAP4_FLAG_Draft:0);
   } 

  lseek(dboximap4.index, (nr-1)*sizeof dboximap4.fi, SEEK_SET);
  write(dboximap4.index, &dboximap4.fi, sizeof dboximap4.fi);

  #ifndef DBOX_STANDALONE
  if(dboximap4.fi.flags.deleted) dboximap4.docrunch(dboximap4.up.name);
  // TODO: subfolder
  #endif

  if(!silent)
   {
    std::cout << "* " << nr << " FETCH ";
    dboximap4.begin_list();
    fetch("FLAGS");
    if(uid) fetch("UID");   
    dboximap4.end_list();
    std::cout << "\r\n";
   }

  return FALSE;
 }

void store_set_commandt::end()
 {
  dboximap4.fp.unlock();
 }

