/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <iostream>

#include <logf.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include <dboxpath.h>
#include "dboximap4.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("") { }
 };

int parseoptionst::doit()
 {
  #ifndef DBOX_STANDALONE
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="dboximap4.log";
    logf.setlogfile(logfile);
   } 
  #endif

  dboximap4t dboximap4;
  dboximap4.doimap4();

  return 0;
 }

void parseoptionst::help()
 {
  std::cerr <<
    "\n"
  #ifdef DBOX_STANDALONE
    "* * DKIMAP4 - Version " DBOXVERSIONNR " * *\n"
  #else
    "* * DBOXIMAP4 - DBOX module for IMAP4 - Version " DBOXVERSIONNR " * *\n"
  #endif
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " dboximap4 [-?] [-h]          Print usage notes\n"
    "\n"
    "Additional options:\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  #ifdef DBOX_STANDALONE
  logf.openlog("dkimap4");
  #endif

  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
