/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <ctype.h>

#include <sbase64.h>
#include <general.h>
#include "mod-utf7.h"

std::string encode_mod_utf7(const std::string &source)
 {
  std::string dest;

  for(unsigned i=0; i<source.size();)
   {
    register char ch=source[i];

    if(ch=='&')
     { dest+="&-"; i++; }
    else if(isascii(ch) && !iscntrl(ch))
     { dest+=ch; i++; }
    else
     {
      std::string data;

      data+='\x0';
      data+=ch;

      for(i++; i<source.size(); i++)
       {
        ch=source[i];
        if(ch=='&' || (isascii(ch) && !iscntrl(ch)))
          break;

        data+='\x0';
        data+=ch;
       }

      dest+='&';
      dest+=sbase64_encode(data, '+', ',', 0);
      dest+='-';
     } 
   }

  return dest;
 }

std::string decode_mod_utf7(const std::string &source)
 {
  std::string dest;

  for(unsigned i=0; i<source.size(); i++)
   {
    register char ch=source[i];
    if(ch=='&')
     {
      std::string utf7, data;

      for(i++; i<source.size(); i++)
        if(source[i]=='-')
          break;
        else
          utf7+=source[i];

      if(utf7=="")
        dest+='&';
      else
       {
        data=sbase64_decode(utf7, '+', ',');
        for(unsigned j=0; (j+1)<data.size(); j+=2)
         {
          char ch2=data[j+1], ch1=data[j];
          if(ch1==0)
            dest+=ch2;
          else // real unicode
           {
           }
         }
       }
     }
    else
      dest+=ch;
   }

  return dest;
 }

#if 0
int main(int argc, char **argv)
 {
  std::string s;

  if(argc!=3) return 0;
  if(atoi(argv[1])==1)
   {
    decode_mod_utf7(argv[2], s);
    cout << ">" << s << "<\n";
   }
  else if(atoi(argv[1])==2)
   {
    encode_mod_utf7(argv[2], s);
    cout << ">" << s << "<\n";
   }
 }
#endif
