/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <tools.h>
#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "dboxpop3.h"
#include "pop.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("") { }
 };

int parseoptionst::doit()
 {
  #ifndef DBOX_STANDALONE
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="dboxpop3.log";
    logf.setlogfile(logfile);
   }
  #endif

  dopop3();

  return 0;
 }

void parseoptionst::help()
 {
  cerr <<
    "\n"
    "* * DBOXPOP3 - DBOX module for POP3 - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " dboxpop3 [-?] [-h]           Print usage notes\n"
    "\n"
    "Additional options:\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  #ifdef DBOX_STANDALONE
  logf.openlog("dkimap4");
  #endif

  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
