/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

#include <algorithm>

#include <dboxpath.h>
#include <tools.h>
#include <nls.h>
#include <folder.h>
#include <charsettools.h>
#include <stringtools.h>
#include <mimedecode.h>
#include <rfc1522.h>
#include <htmltools.h>

#include "ostatus.h"
#include "webgetrfc.h"
#include "webtools.h"
#include "formatmessage.h"
#include "readwebmail.h"

void readwebmail(ostream &out, getrfct &getrfc,
                 dword msgnr, const string &msg_id,
                 bool show_mimestruct)
 {
   {
    string title=nls.get("webonline.mail.title");
    title+=' ';
    title+=status.username;
    startpage(out, title);
   }

  if(getrfc.get_structure(msgnr))
   {
    out << "<p>Error: failed to get message!</p>\n";
   }
  else
   {
    format_message(out, show_mimestruct, FALSE,
                   msg_id, "/email", *getrfc.mimestruct, getrfc.rfcm);
   }

  endpage(out);
 }
